module Types where 

type Program = [Instruction]

type Name = String

type Value = Int

data Instruction = Assignment Name Value deriving Show

valueOf (Assignment _ val) = val
idOf (Assignment id _) = id

data CompilationResult = Success Program | SyntaxError String | SemanticError String
    deriving Show

compileOK (Success p) = True
compileOK _ = False

messageOf (Success p) = error "Compilation was a success, no message available"
messageOf (SyntaxError s) = s
messageOf (SemanticError s) = s

programOf (Success p) = p
programOf _ = error "Compilation was a failure, no program available"

