import Language
import Grammar
import Types

import qualified System
import qualified System.IO as IO

compile filename = do
  -- putStrLn ("Trying " ++ filename ++ "...")
  f <- IO.openFile (filename) IO.ReadMode
  input <- IO.hGetContents f
  let syntaxTree = parse input
  if (compileOK syntaxTree) then do
      let result = semanticCheck (programOf syntaxTree)
      if (compileOK result) then 
          putStrLn (filename ++ " is OK")
       else 
          putStrLn ("Semantic error in " ++ filename ++ ": " ++ (messageOf result))
   else
      putStrLn ("Syntax error in " ++ filename ++ ": " ++ (messageOf syntaxTree))
  putStrLn ""

foreach [] func = return ()
foreach a func = do
   func (head a)
   foreach (tail a) func

main = do
    myargs <- System.getArgs
    foreach myargs compile 
    return ()
